package salaComunitaria.objectsDAO;

import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;

import salaComunitaria.interfacesDAO.GenericDAO;

public abstract class GenericDAOAbs<T> implements GenericDAO<T> {

	protected Type classType;

	public GenericDAOAbs() {
		Type superClass = getClass().getGenericSuperclass();
		this.classType = ((ParameterizedType) superClass).getActualTypeArguments()[0];
	}
}
