package salaComunitaria.servlets;

import jakarta.inject.Inject;
import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import salaComunitaria.entities.*;
import salaComunitaria.interfacesDAO.*;

import java.io.IOException;
import java.time.LocalDate;
import java.time.ZoneId;
import java.time.temporal.ChronoUnit;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Servlet implementation class Entrega3
 */
public class Entrega3 extends HttpServlet {
	
	private static final long serialVersionUID = 1L;
	
	@Inject
	private UserDAO uDAO;
	
	@Inject
	private ProviderDAO pDAO;
	
	@Inject
	private InputDAO iDAO;
	
	@Inject
	private BatchDAO bDAO;
	
	@Inject
	private RawMaterialDAO rDAO;
	
	@Inject
	private RecipeDAO reDAO;
	
	@Inject
	private SalesChannelDAO sDAO;
	
	@Inject
	private EventDAO eDAO;
	
  
    public Entrega3() {
        super();
    }

//	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
//		response.getWriter().append("Served at: ").append(request.getContextPath());
//		
//		//Create Users
//		System.out.println("Creo 2 Usuarios");
//		User u = new User();
//		u.setName("Francisca");
//		u.setSurname("Gonzales");
//		u.setEmail("ejemplo@ejemplo.com");
//		u.setPhone("+5492396789856");
//		u.setRole("Admin");
//		uDAO.create(u);
//		User u2 = new User();
//		u2.setName("Juan");
//		u2.setSurname("Gonzales");
//		u2.setEmail("ejemplo2@ejemplo.com");
//		u2.setPhone("+5492393389856");
//		u2.setRole("User");
//		uDAO.create(u2);
//		System.out.println("Muestro Usuarios");
//		List<User> users = uDAO.get();
//		
//		for(User us : users){
//			System.out.println(us.toString());
//		}
//		System.out.println("Edito un Usuario");
//		//Modify User
//		u.setName("Milagros");
//		u.setEmail("editado@ejemplo.com");
//		uDAO.modify(u);
//		users = uDAO.get();
//		
//		for(User us : users){
//			System.out.println(us.toString());
//		}
//		System.out.println("Elimino un Usuario");
//		
//		//Eliminate User
//		uDAO.delete(u2);
//		
//		users = uDAO.get();
//		for(User us : users){
//			System.out.println(us.toString());
//		}
//		//Providers
//		System.out.println("Creo Provedores");
//		Provider p = new Provider();
//		p.setName("Granja del Sol");
//		p.setAddress("Calle 3, 1500, Oficina 2");
//		p.setCuit("20-456876-11");
//		p.setDescription("");
//		p.setEmail("gs@ejemplo.com");
//		p.setPhone("2214509821");
//		pDAO.create(p);
//		Provider p2 = new Provider();
//		p2.setName("Papelera Rodriguez");
//		p2.setAddress("Calle 10, 2500");
//		p2.setCuit("20-444876-11");
//		p2.setDescription("");
//		p2.setEmail("pr@ejemplo.com");
//		p2.setPhone("2214509823");
//		pDAO.create(p2);
//		Provider p3 = new Provider();
//		p3.setName("Papelera Rodriguez");
//		p3.setAddress("Calle 10, 2500");
//		p3.setCuit("20-444876-11");
//		p3.setDescription("");
//		p3.setEmail("pr@ejemplo.com");
//		p3.setPhone("2214509823");
//		pDAO.create(p3);
//		List<Provider> providers = pDAO.get();
//		for(Provider aux : providers){
//			System.out.println(aux.toString());
//		}
//		//Modify
//		System.out.println("Modifico un Provedor");
//		p.setDescription("EDITADO");
//		pDAO.modify(p);
//		providers = pDAO.get();
//		for(Provider aux : providers){
//			System.out.println(aux.toString());
//		}
//		
//		//Delete
//		System.out.println("Elimino un Provedor");
//		pDAO.delete(p3);
//		providers = pDAO.get();
//		for(Provider aux : providers){
//			System.out.println(aux.toString());
//		}
//		
//		//Inputs
//		System.out.println("Creo Insumos");
//		Input i = new Input();
//		i.setName("Tapas de Frazcos");
//		i.setDescription("");
//		i.setAdmissionDate(new Date());
//		i.setCost(20000);
//		i.setLastModificationDate(new Date());
//		i.setQuantity(200);
//		i.setType("Tapas");
//		i.setUnit("Unidad");
//		i.setProvider(p2);
//		iDAO.create(i);
//		
//		Input i2 = new Input();
//		i2.setName("Frazco de Vidrio 360ml");
//		i2.setDescription("");
//		i2.setAdmissionDate(new Date());
//		i2.setCost(50000);
//		i2.setLastModificationDate(new Date());
//		i2.setQuantity(200);
//		i2.setType("Frazcos");
//		i2.setUnit("Unidad");
//		i2.setProvider(p2);
//		iDAO.create(i2);
//		List<Input> inputs = iDAO.get();
//		for(Input aux : inputs){
//			System.out.println(aux.toString());
//		}
//		//Modify
//		System.out.println("Modifico un Insumo");
//		i2.setName("Frazco de Vidrio");
//		i2.setDescription("360ml");
//		iDAO.modify(i2);
//		inputs = iDAO.get();
//		for(Input aux : inputs){
//			System.out.println(aux.toString());
//		}
//		//Delete
//		System.out.println("Elimino un Insumo");
//		iDAO.delete(i);
//		inputs = iDAO.get();
//		for(Input aux : inputs){
//			System.out.println(aux.toString());
//		}
//		
//		//RawMaterial
//		System.out.println("Creo Materia Prima");
//		RawMaterial r = new RawMaterial();
//		r.setName("Manzanas");
//		r.setProvider(p);
//		r.setAdmissionDate(new Date());
//		r.setCost(200000);
//		r.setDescripction("Manzanas Rojas");
//		r.setFreeze(true);
//		LocalDate currentDate = LocalDate.now();
//		LocalDate expirationDate = currentDate.plus(6, ChronoUnit.MONTHS);
//		Date expirationDateAsDate = Date.from(expirationDate.atStartOfDay(ZoneId.systemDefault()).toInstant());
//		r.setExpirationDate(expirationDateAsDate);
//		r.setLastModificationDate(new Date());
//		r.setQuantity(1000);
//		r.setUnit("Kg");
//		r.setType("Fruta");
//		rDAO.create(r);
//		
//		RawMaterial r2 = new RawMaterial();
//		r2.setName("Semillas de Girasol");
//		r2.setProvider(p);
//		r2.setAdmissionDate(new Date());
//		r2.setCost(50000);
//		r2.setDescripction("Semillas de Girasol");
//		r2.setFreeze(false);
//		r2.setExpirationDate(new Date());
//		r2.setLastModificationDate(new Date());
//		r2.setQuantity(100);
//		r2.setUnit("Kg");
//		r2.setType("Semillas");
//		rDAO.create(r2);
//		
//		RawMaterial r3 = new RawMaterial();
//		r3.setName("Semillas de Zapallo");
//		r3.setProvider(p);
//		r3.setAdmissionDate(new Date());
//		r3.setCost(12000);
//		r3.setDescripction("");
//		r3.setFreeze(false);
//		r3.setExpirationDate(new Date());
//		r3.setLastModificationDate(new Date());
//		r3.setQuantity(10);
//		r3.setUnit("Kg");
//		r3.setType("Semillas");
//		rDAO.create(r3);
//		List<RawMaterial> materials = rDAO.get();
//		for(RawMaterial aux : materials){
//			System.out.println(aux.toString());
//		}
//		//Modify
//		System.out.println("Modifico una Materia Prima");
//		r2.setDescripction("Semillas de Girasol Premium");
//		rDAO.modify(r2);
//		materials = rDAO.get();
//		for(RawMaterial aux : materials){
//			System.out.println(aux.toString());
//		}
//		//Delete
//		System.out.println("Elimino una Materia Prima");
//		rDAO.delete(r3);
//		materials = rDAO.get();
//		for(RawMaterial aux : materials){
//			System.out.println(aux.toString());
//		}
//		
//		//Recipes
//		System.out.println("Creo Recetas");
//		Recipe re = new Recipe();
//		re.setName("Mermelada de Manzana");
//		re.setDescription("Mermelada de Manzan 100% Organica");
//		re.setRecipeIngredients("5 Manzanas, 100gr de Azucar");
//		re.setRecipePackagingElements("Frazco 360ml, Tapa");
//		reDAO.create(re);
//		Recipe re2 = new Recipe();
//		re2.setName("Mermelada de Durazno");
//		re2.setDescription("Mermelada de Durazno Light");
//		re2.setRecipeIngredients("3 Duraznos, 100gr de Azucar");
//		re2.setRecipePackagingElements("Frazco 360ml, Tapa");
//		reDAO.create(re2);
//		List<Recipe> recipes = reDAO.get();
//		for(Recipe aux : recipes){
//			System.out.println(aux.toString());
//		}
//		//Modify
//		System.out.println("Modifico una Receta");
//		re2.setDescription("Mermelada de Durazno");
//		reDAO.modify(re2);
//		recipes = reDAO.get();
//		for(Recipe aux : recipes){
//			System.out.println(aux.toString());
//		}
//		//Delete
//		System.out.println("Elimino una Receta");
//		reDAO.delete(re2);
//		recipes = reDAO.get();
//		for(Recipe aux : recipes){
//			System.out.println(aux.toString());
//		}
//		
//		//Batches
//		System.out.println("Creo Lotes");
//		Batch b = new Batch();
//		b.setName("Mermelada de Manzana");
//		b.setCreationDate(new Date());
//		b.setCategory("Mermeladas");
//		b.setDescription("Mermelada de Manzan 100% Organica");
//		currentDate = LocalDate.now();
//		expirationDate = currentDate.plus(120, ChronoUnit.MONTHS);
//		expirationDateAsDate = Date.from(expirationDate.atStartOfDay(ZoneId.systemDefault()).toInstant());
//		b.setExpiration(expirationDateAsDate);
//		b.setLastModificationDate(new Date());
//		b.setQuantity(30);
//		b.setUnit("Unidad");
//		b.setRecipe(re);
//		List<RawMaterial> materials2 = new ArrayList<RawMaterial>();
//		materials2.add(r);
//		b.setBatchIngredients(materials2);
//		List<Input> pack21 = new ArrayList<Input>();
//		pack21.add(i2);
//		b.setBatchPackagingElements(pack21);
//		bDAO.create(b);
//		
//		Batch b2 = new Batch();
//		b2.setName("Mermelada de Durazno");
//		b2.setCreationDate(new Date());
//		b2.setCategory("Mermeladas");
//		b2.setDescription("");
//		currentDate = LocalDate.now();
//		expirationDate = currentDate.plus(120, ChronoUnit.MONTHS);
//		expirationDateAsDate = Date.from(expirationDate.atStartOfDay(ZoneId.systemDefault()).toInstant());
//		b2.setExpiration(expirationDateAsDate);
//		b2.setLastModificationDate(new Date());
//		b2.setQuantity(10);
//		b2.setUnit("Unidad");
//		
//		b2.setRecipe(null);
//		List<RawMaterial> materials21 = new ArrayList<RawMaterial>();
//		materials21.add(r);
//		b2.setBatchIngredients(materials21);
//		List<Input> pack211 = new ArrayList<Input>();
//		pack211.add(i2);
//		b2.setBatchPackagingElements(pack211);
//		bDAO.create(b2);
//		List<Batch> batches = bDAO.get();
//		for(Batch aux : batches){
//			System.out.println(aux.toString());
//		}
//		//Modify 
//		System.out.println("Modifico un Lote");
//		b2.setName("Mermelada de Manzana Light");
//		bDAO.modify(b2);
//		batches = bDAO.get();
//		for(Batch aux : batches){
//			System.out.println(aux.toString());
//		}
//		
//		//Delete
//		System.out.println("Elimino un Lote");
//		bDAO.delete(b2);
//		batches = bDAO.get();
//		for(Batch aux : batches){
//			System.out.println(aux.toString());
//		}
//		
//		//SalesChannel
//		System.out.println("Creo Canales de Venta");
//		SalesChannel sc = new SalesChannel();
//		sc.setName("La Justa");
//		sc.setPhone("");
//		sc.setCuit("05-123132123-12");
//		sc.setAddres("Calle 120 esquina 60");
//		sDAO.create(sc);
//		SalesChannel sc2 = new SalesChannel();
//		sc2.setName("Mercado 2");
//		sc2.setPhone("");
//		sc2.setCuit("05-123134423-12");
//		sc2.setAddres("Calle 10 esquina 60");
//		sDAO.create(sc2);
//		List<SalesChannel> saleschannels = sDAO.get();
//		for(SalesChannel aux : saleschannels){
//			System.out.println(aux.toString());
//		}
//		//Modify
//		System.out.println("Modifico un Canal de Venta");
//		sc.setPhone("221-456789");
//		sDAO.modify(sc);
//		saleschannels = sDAO.get();
//		for(SalesChannel aux : saleschannels){
//			System.out.println(aux.toString());
//		}
//		
//		//Delete
//		System.out.println("Elimino un Canal de Venta");
//		sDAO.delete(sc2);
//		saleschannels = sDAO.get();
//		for(SalesChannel aux : saleschannels){
//			System.out.println(aux.toString());
//		}
//		
//		//Event
//		System.out.println("Creo Eventos");
//		ExpiryEvent e = new ExpiryEvent();
//		e.setTitle("Vencimiento: " + r.getName());
//		e.setDescription("Vencimiento: "+r.getName()+", Fecha: "+r.getExpirationDate());
//		e.setEnvenDate(new Date());
//	    e.setRawMaterial(r);
//	    eDAO.create(e);
//	    
//	    SaleEvent e2 = new SaleEvent();
//		e2.setTitle("Venta de: "+b.getName());
//		e2.setQuantitySold(b.getQuantity()/2);
//		e2.setCost(e2.getQuantitySold()*200);
//		e2.setDescription("");
//		e2.setEnvenDate(new Date());
//		List<Batch> sb = new ArrayList<Batch>();
//		sb.add(b);
//		e2.setSoldBatches(sb);
//		e2.setUnit("Unidad");
//		e2.setUser(u);
//		eDAO.create(e2);
//	    
//	    List<Event> events = eDAO.get();
//	    System.out.println("Listo Eventos");
//	    for(Event aux : events){
//			System.out.println(aux.toString());
//		}
//	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

}
